
<!DOCTYPE html>


<html lang="en" data-content_root="../../../" >

  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" /><meta name="viewport" content="width=device-width, initial-scale=1" />

    <title>Export &#8212; Eclipse Aidge  documentation</title>
  
  
  
  <script data-cfasync="false">
    document.documentElement.dataset.mode = localStorage.getItem("mode") || "";
    document.documentElement.dataset.theme = localStorage.getItem("theme") || "";
  </script>
  <!--
    this give us a css class that will be invisible only if js is disabled
  -->
  <noscript>
    <style>
      .pst-js-only { display: none !important; }

    </style>
  </noscript>
  
  <!-- Loaded before other Sphinx assets -->
  <link href="../../../_static/styles/theme.css?digest=8878045cc6db502f8baf" rel="stylesheet" />
<link href="../../../_static/styles/pydata-sphinx-theme.css?digest=8878045cc6db502f8baf" rel="stylesheet" />

    <link rel="stylesheet" type="text/css" href="../../../_static/pygments.css?v=8f2a1f02" />
    <link rel="stylesheet" type="text/css" href="../../../_static/graphviz.css?v=4ae1632d" />
    <link rel="stylesheet" type="text/css" href="../../../_static/copybutton.css?v=76b2166b" />
    <link rel="stylesheet" type="text/css" href="../../../_static/sg_gallery.css?v=d2d258e8" />
    <link rel="stylesheet" type="text/css" href="../../../_static/sphinx-design.min.css?v=95c83b7e" />
    <link rel="stylesheet" type="text/css" href="../../../_static/css/custom.css?v=794b2ffd" />
  
  <!-- So that users can add custom icons -->
  <script src="../../../_static/scripts/fontawesome.js?digest=8878045cc6db502f8baf"></script>
  <!-- Pre-loaded scripts that we'll load fully later -->
  <link rel="preload" as="script" href="../../../_static/scripts/bootstrap.js?digest=8878045cc6db502f8baf" />
<link rel="preload" as="script" href="../../../_static/scripts/pydata-sphinx-theme.js?digest=8878045cc6db502f8baf" />

    <script src="../../../_static/documentation_options.js?v=5929fcd5"></script>
    <script src="../../../_static/doctools.js?v=9bcbadda"></script>
    <script src="../../../_static/sphinx_highlight.js?v=dc90522c"></script>
    <script src="../../../_static/clipboard.min.js?v=a7894cd8"></script>
    <script src="../../../_static/copybutton.js?v=f281be69"></script>
    <script src="../../../_static/design-tabs.js?v=f930bc37"></script>
    <script src="https://cdn.jsdelivr.net/npm/@jupyter-widgets/html-manager@^1.0.1/dist/embed-amd.js"></script>
    <script>DOCUMENTATION_OPTIONS.pagename = 'source/API/Core/export';</script>
    <script>
        DOCUMENTATION_OPTIONS.theme_version = '0.16.1';
        DOCUMENTATION_OPTIONS.theme_switcher_json_url = 'https://eclipse-aidge.readthedocs.io/en/dev/_static/version_switcher.json';
        DOCUMENTATION_OPTIONS.theme_switcher_version_match = '0.5.0';
        DOCUMENTATION_OPTIONS.show_version_warning_banner =
            false;
        </script>
    <script src="../../../_static/js/mermaid.min.js"></script>
    <link rel="index" title="Index" href="../../../genindex.html" />
    <link rel="search" title="Search" href="../../../search.html" />
    <link rel="next" title="Aidge backend CPU" href="../BackendCPU/index.html" />
    <link rel="prev" title="Recipes" href="recipes.html" />
  <meta name="viewport" content="width=device-width, initial-scale=1"/>
  <meta name="docsearch:language" content="en"/>
  <meta name="docsearch:version" content="0.5.0" />
  </head>
  
  
  <body data-bs-spy="scroll" data-bs-target=".bd-toc-nav" data-offset="180" data-bs-root-margin="0px 0px -60%" data-default-mode="">

  
  
  <div id="pst-skip-link" class="skip-link d-print-none"><a href="#main-content">Skip to main content</a></div>
  
  <div id="pst-scroll-pixel-helper"></div>
  
  <button type="button" class="btn rounded-pill" id="pst-back-to-top">
    <i class="fa-solid fa-arrow-up"></i>Back to top</button>

  
  <dialog id="pst-search-dialog">
    
<form class="bd-search d-flex align-items-center"
      action="../../../search.html"
      method="get">
  <i class="fa-solid fa-magnifying-glass"></i>
  <input type="search"
         class="form-control"
         name="q"
         placeholder="Search the docs ..."
         aria-label="Search the docs ..."
         autocomplete="off"
         autocorrect="off"
         autocapitalize="off"
         spellcheck="false"/>
  <span class="search-button__kbd-shortcut"><kbd class="kbd-shortcut__modifier">Ctrl</kbd>+<kbd>K</kbd></span>
</form>
  </dialog>

  <div class="pst-async-banner-revealer d-none">
  <aside id="bd-header-version-warning" class="d-none d-print-none" aria-label="Version warning"></aside>
</div>

  
    <header class="bd-header navbar navbar-expand-lg bd-navbar d-print-none">
<div class="bd-header__inner bd-page-width">
  <button class="pst-navbar-icon sidebar-toggle primary-toggle" aria-label="Site navigation">
    <span class="fa-solid fa-bars"></span>
  </button>
  
  
  <div class="col-lg-3 navbar-header-items__start">
    
      <div class="navbar-item">

  
    
  

<a class="navbar-brand logo" href="../../../index.html">
  
  
  
  
  
    
    
      
    
    
    <img src="../../../_static/Isotype-aidge.png" class="logo__image only-light" alt=""/>
    <img src="../../../_static/Isotype-aidge.png" class="logo__image only-dark pst-js-only" alt=""/>
  
  
    <p class="title logo__title">Eclipse Aidge</p>
  
</a></div>
    
      <div class="navbar-item">
<div class="version-switcher__container dropdown pst-js-only">
  <button id="pst-version-switcher-button-2"
    type="button"
    class="version-switcher__button btn btn-sm dropdown-toggle"
    data-bs-toggle="dropdown"
    aria-haspopup="listbox"
    aria-controls="pst-version-switcher-list-2"
    aria-label="Version switcher list"
  >
    Choose version  <!-- this text may get changed later by javascript -->
    <span class="caret"></span>
  </button>
  <div id="pst-version-switcher-list-2"
    class="version-switcher__menu dropdown-menu list-group-flush py-0"
    role="listbox" aria-labelledby="pst-version-switcher-button-2">
    <!-- dropdown will be populated by javascript on page load -->
  </div>
</div></div>
    
  </div>
  
  <div class="col-lg-9 navbar-header-items">
    
    <div class="me-auto navbar-header-items__center">
      
        <div class="navbar-item">
<nav>
  <ul class="bd-navbar-elements navbar-nav">
    
<li class="nav-item ">
  <a class="nav-link nav-internal" href="../../GetStarted/index.html">
    Get Started
  </a>
</li>


<li class="nav-item ">
  <a class="nav-link nav-internal" href="../../UserGuide/index.html">
    User Guide
  </a>
</li>


<li class="nav-item ">
  <a class="nav-link nav-internal" href="../../Tutorial/index.html">
    Tutorials
  </a>
</li>


<li class="nav-item current active">
  <a class="nav-link nav-internal" href="../index.html">
    API
  </a>
</li>

  </ul>
</nav></div>
      
    </div>
    
    
    <div class="navbar-header-items__end">
      
        <div class="navbar-item navbar-persistent--container">
          

<button class="btn search-button-field search-button__button pst-js-only" title="Search" aria-label="Search" data-bs-placement="bottom" data-bs-toggle="tooltip">
 <i class="fa-solid fa-magnifying-glass"></i>
 <span class="search-button__default-text">Search</span>
 <span class="search-button__kbd-shortcut"><kbd class="kbd-shortcut__modifier">Ctrl</kbd>+<kbd class="kbd-shortcut__modifier">K</kbd></span>
</button>
        </div>
      
      
        <div class="navbar-item">

<button class="btn btn-sm nav-link pst-navbar-icon theme-switch-button pst-js-only" aria-label="Color mode" data-bs-title="Color mode"  data-bs-placement="bottom" data-bs-toggle="tooltip">
  <i class="theme-switch fa-solid fa-sun                fa-lg" data-mode="light" title="Light"></i>
  <i class="theme-switch fa-solid fa-moon               fa-lg" data-mode="dark"  title="Dark"></i>
  <i class="theme-switch fa-solid fa-circle-half-stroke fa-lg" data-mode="auto"  title="System Settings"></i>
</button></div>
      
        <div class="navbar-item"><ul class="navbar-icon-links"
    aria-label="Icon Links">
        <li class="nav-item">
          
          
          
          
          
          
          
          
          <a href="<https://gitlab.eclipse.org/eclipse/aidge>" title="GitLab" class="nav-link pst-navbar-icon" rel="noopener" target="_blank" data-bs-toggle="tooltip" data-bs-placement="bottom"><i class="fab fa-gitlab fa-lg" aria-hidden="true"></i>
            <span class="sr-only">GitLab</span></a>
        </li>
</ul></div>
      
    </div>
    
  </div>
  
  
    <div class="navbar-persistent--mobile">

<button class="btn search-button-field search-button__button pst-js-only" title="Search" aria-label="Search" data-bs-placement="bottom" data-bs-toggle="tooltip">
 <i class="fa-solid fa-magnifying-glass"></i>
 <span class="search-button__default-text">Search</span>
 <span class="search-button__kbd-shortcut"><kbd class="kbd-shortcut__modifier">Ctrl</kbd>+<kbd class="kbd-shortcut__modifier">K</kbd></span>
</button>
    </div>
  

  
    <button class="pst-navbar-icon sidebar-toggle secondary-toggle" aria-label="On this page">
      <span class="fa-solid fa-outdent"></span>
    </button>
  
</div>

    </header>
  

  <div class="bd-container">
    <div class="bd-container__inner bd-page-width">
      
      
      
      <dialog id="pst-primary-sidebar-modal"></dialog>
      <div id="pst-primary-sidebar" class="bd-sidebar-primary bd-sidebar">
        

  
  <div class="sidebar-header-items sidebar-primary__section">
    
    
      <div class="sidebar-header-items__center">
        
          
          
            <div class="navbar-item">
<nav>
  <ul class="bd-navbar-elements navbar-nav">
    
<li class="nav-item ">
  <a class="nav-link nav-internal" href="../../GetStarted/index.html">
    Get Started
  </a>
</li>


<li class="nav-item ">
  <a class="nav-link nav-internal" href="../../UserGuide/index.html">
    User Guide
  </a>
</li>


<li class="nav-item ">
  <a class="nav-link nav-internal" href="../../Tutorial/index.html">
    Tutorials
  </a>
</li>


<li class="nav-item current active">
  <a class="nav-link nav-internal" href="../index.html">
    API
  </a>
</li>

  </ul>
</nav></div>
          
        
      </div>
    
    
    
      <div class="sidebar-header-items__end">
        
          <div class="navbar-item">

<button class="btn btn-sm nav-link pst-navbar-icon theme-switch-button pst-js-only" aria-label="Color mode" data-bs-title="Color mode"  data-bs-placement="bottom" data-bs-toggle="tooltip">
  <i class="theme-switch fa-solid fa-sun                fa-lg" data-mode="light" title="Light"></i>
  <i class="theme-switch fa-solid fa-moon               fa-lg" data-mode="dark"  title="Dark"></i>
  <i class="theme-switch fa-solid fa-circle-half-stroke fa-lg" data-mode="auto"  title="System Settings"></i>
</button></div>
        
          <div class="navbar-item"><ul class="navbar-icon-links"
    aria-label="Icon Links">
        <li class="nav-item">
          
          
          
          
          
          
          
          
          <a href="<https://gitlab.eclipse.org/eclipse/aidge>" title="GitLab" class="nav-link pst-navbar-icon" rel="noopener" target="_blank" data-bs-toggle="tooltip" data-bs-placement="bottom"><i class="fab fa-gitlab fa-lg" aria-hidden="true"></i>
            <span class="sr-only">GitLab</span></a>
        </li>
</ul></div>
        
      </div>
    
  </div>
  
    <div class="sidebar-primary-items__start sidebar-primary__section">
        <div class="sidebar-primary-item">
<nav class="bd-docs-nav bd-links"
     aria-label="Section Navigation">
  <p class="bd-links__title" role="heading" aria-level="1">Section Navigation</p>
  <div class="bd-toc-item navbar-nav"><ul class="current nav bd-sidenav">
<li class="toctree-l1 current active has-children"><a class="reference internal" href="index.html">Aidge core API</a><details open="open"><summary><span class="toctree-toggle" role="presentation"><i class="fa-solid fa-chevron-down"></i></span></summary><ul class="current">
<li class="toctree-l2"><a class="reference internal" href="data.html">Data</a></li>
<li class="toctree-l2"><a class="reference internal" href="graph.html">Graph</a></li>
<li class="toctree-l2"><a class="reference internal" href="operator.html">Operators</a></li>
<li class="toctree-l2"><a class="reference internal" href="backend.html">Backend</a></li>
<li class="toctree-l2"><a class="reference internal" href="scheduler.html">Scheduler</a></li>
<li class="toctree-l2"><a class="reference internal" href="graphMatching.html">Graph Matching</a></li>
<li class="toctree-l2"><a class="reference internal" href="recipes.html">Recipes</a></li>
<li class="toctree-l2 current active"><a class="current reference internal" href="#">Export</a></li>
</ul>
</details></li>
<li class="toctree-l1"><a class="reference internal" href="../BackendCPU/index.html">Aidge backend CPU</a></li>
<li class="toctree-l1"><a class="reference internal" href="../Onnx/index.html">Aidge ONNX API</a></li>
<li class="toctree-l1"><a class="reference internal" href="../BackendOPENCV/index.html">Aidge backend OpenCV API</a></li>
<li class="toctree-l1"><a class="reference internal" href="../ExportTensorRT/index.html">Aidge Export TensorRT API</a></li>
</ul>
</div>
</nav></div>
    </div>
  
  
  <div class="sidebar-primary-items__end sidebar-primary__section">
      <div class="sidebar-primary-item">
<div id="ethical-ad-placement"
      class="flat"
      data-ea-publisher="readthedocs"
      data-ea-type="readthedocs-sidebar"
      data-ea-manual="true">
</div></div>
  </div>


      </div>
      
      <main id="main-content" class="bd-main" role="main">
        
        
          <div class="bd-content">
            <div class="bd-article-container">
              
              <div class="bd-header-article d-print-none">
<div class="header-article-items header-article__inner">
  
    <div class="header-article-items__start">
      
        <div class="header-article-item">

<nav aria-label="Breadcrumb" class="d-print-none">
  <ul class="bd-breadcrumbs">
    
    <li class="breadcrumb-item breadcrumb-home">
      <a href="../../../index.html" class="nav-link" aria-label="Home">
        <i class="fa-solid fa-home"></i>
      </a>
    </li>
    
    <li class="breadcrumb-item"><a href="../index.html" class="nav-link">API</a></li>
    
    
    <li class="breadcrumb-item"><a href="index.html" class="nav-link">Aidge core API</a></li>
    
    <li class="breadcrumb-item active" aria-current="page"><span class="ellipsis">Export</span></li>
  </ul>
</nav>
</div>
      
    </div>
  
  
</div>
</div>
              
              
              
                
<div id="searchbox"></div>
                <article class="bd-article">
                  
  <section id="export">
<h1>Export<a class="headerlink" href="#export" title="Link to this heading">#</a></h1>
<section id="export-lib">
<h2>Export lib<a class="headerlink" href="#export-lib" title="Link to this heading">#</a></h2>
<dl class="py class">
<dt class="sig sig-object py" id="aidge_core.export_utils.ExportLib">
<em class="property"><span class="pre">class</span><span class="w"> </span></em><span class="sig-prename descclassname"><span class="pre">aidge_core.export_utils.</span></span><span class="sig-name descname"><span class="pre">ExportLib</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">operator</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#aidge_core.export_utils.ExportLib" title="Link to this definition">#</a></dt>
<dd><p>Aidge export library that manages a registry for operators and static files.</p>
<p>This class provides a structure for registering different operator types and
export nodes, facilitating access and management of these elements.</p>
<dl class="field-list simple">
<dt class="field-odd">Variables<span class="colon">:</span></dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>_name</strong> – The name of the export library, used for namespacing.</p></li>
<li><p><strong>static_files</strong> – A dictionary mapping paths of static files to their target locations relative to the export root.</p></li>
</ul>
</dd>
</dl>
<dl class="py method">
<dt class="sig sig-object py" id="aidge_core.export_utils.ExportLib.__init__">
<span class="sig-name descname"><span class="pre">__init__</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">self:</span> <span class="pre">aidge_core.aidge_core.OperatorImpl</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">arg0:</span> <span class="pre">Aidge::Operator</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">arg1:</span> <span class="pre">str</span></span></em><span class="sig-paren">)</span> <span class="sig-return"><span class="sig-return-icon">&#x2192;</span> <span class="sig-return-typehint"><span class="pre">None</span></span></span><a class="headerlink" href="#aidge_core.export_utils.ExportLib.__init__" title="Link to this definition">#</a></dt>
<dd></dd></dl>

<dl class="py method">
<dt class="sig sig-object py" id="aidge_core.export_utils.ExportLib.backend">
<span class="sig-name descname"><span class="pre">backend</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">self</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">aidge_core.aidge_core.OperatorImpl</span></span></em><span class="sig-paren">)</span> <span class="sig-return"><span class="sig-return-icon">&#x2192;</span> <span class="sig-return-typehint"><span class="pre">str</span></span></span><a class="headerlink" href="#aidge_core.export_utils.ExportLib.backend" title="Link to this definition">#</a></dt>
<dd></dd></dl>

<dl class="py method">
<dt class="sig sig-object py" id="aidge_core.export_utils.ExportLib.backward">
<span class="sig-name descname"><span class="pre">backward</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">self</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">aidge_core.aidge_core.OperatorImpl</span></span></em><span class="sig-paren">)</span> <span class="sig-return"><span class="sig-return-icon">&#x2192;</span> <span class="sig-return-typehint"><span class="pre">None</span></span></span><a class="headerlink" href="#aidge_core.export_utils.ExportLib.backward" title="Link to this definition">#</a></dt>
<dd></dd></dl>

<dl class="py method">
<dt class="sig sig-object py" id="aidge_core.export_utils.ExportLib.forward">
<span class="sig-name descname"><span class="pre">forward</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">self</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">aidge_core.aidge_core.OperatorImpl</span></span></em><span class="sig-paren">)</span> <span class="sig-return"><span class="sig-return-icon">&#x2192;</span> <span class="sig-return-typehint"><span class="pre">None</span></span></span><a class="headerlink" href="#aidge_core.export_utils.ExportLib.forward" title="Link to this definition">#</a></dt>
<dd></dd></dl>

<dl class="py method">
<dt class="sig sig-object py" id="aidge_core.export_utils.ExportLib.get_adaptation">
<span class="sig-name descname"><span class="pre">get_adaptation</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">self</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">aidge_core.aidge_core.OperatorImpl</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">arg0</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><a class="reference internal" href="backend.html#aidge_core.ImplSpec" title="aidge_core.aidge_core.ImplSpec"><span class="pre">aidge_core.aidge_core.ImplSpec</span></a></span></em>, <em class="sig-param"><span class="n"><span class="pre">arg1</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><a class="reference internal" href="backend.html#aidge_core.ImplSpec" title="aidge_core.aidge_core.ImplSpec"><span class="pre">aidge_core.aidge_core.ImplSpec</span></a></span></em><span class="sig-paren">)</span> <span class="sig-return"><span class="sig-return-icon">&#x2192;</span> <span class="sig-return-typehint"><a class="reference internal" href="graph.html#aidge_core.Node" title="aidge_core.aidge_core.Node"><span class="pre">aidge_core.aidge_core.Node</span></a></span></span><a class="headerlink" href="#aidge_core.export_utils.ExportLib.get_adaptation" title="Link to this definition">#</a></dt>
<dd></dd></dl>

<dl class="py method">
<dt class="sig sig-object py" id="aidge_core.export_utils.ExportLib.get_available_impl_specs">
<span class="sig-name descname"><span class="pre">get_available_impl_specs</span></span><span class="sig-paren">(</span><span class="sig-paren">)</span> <span class="sig-return"><span class="sig-return-icon">&#x2192;</span> <span class="sig-return-typehint"><span class="pre">List</span><span class="p"><span class="pre">[</span></span><a class="reference internal" href="backend.html#aidge_core.ImplSpec" title="aidge_core.aidge_core.ImplSpec"><span class="pre">ImplSpec</span></a><span class="p"><span class="pre">]</span></span></span></span><a class="headerlink" href="#aidge_core.export_utils.ExportLib.get_available_impl_specs" title="Link to this definition">#</a></dt>
<dd><p>Override the virtual OperatorImpl method, in order to provide available
implementation specifications.</p>
<dl class="field-list simple">
<dt class="field-odd">Returns<span class="colon">:</span></dt>
<dd class="field-odd"><p>List of implementation specification available for the type of operator.</p>
</dd>
<dt class="field-even">Return type<span class="colon">:</span></dt>
<dd class="field-even"><p>List[<a class="reference internal" href="backend.html#aidge_core.ImplSpec" title="aidge_core.ImplSpec">aidge_core.ImplSpec</a>]</p>
</dd>
</dl>
</dd></dl>

<dl class="py method">
<dt class="sig sig-object py" id="aidge_core.export_utils.ExportLib.get_best_adaptation">
<span class="sig-name descname"><span class="pre">get_best_adaptation</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">self</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">aidge_core.aidge_core.OperatorImpl</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">arg0</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><a class="reference internal" href="backend.html#aidge_core.ImplSpec" title="aidge_core.aidge_core.ImplSpec"><span class="pre">aidge_core.aidge_core.ImplSpec</span></a></span></em><span class="sig-paren">)</span> <span class="sig-return"><span class="sig-return-icon">&#x2192;</span> <span class="sig-return-typehint"><a class="reference internal" href="graph.html#aidge_core.Node" title="aidge_core.aidge_core.Node"><span class="pre">aidge_core.aidge_core.Node</span></a></span></span><a class="headerlink" href="#aidge_core.export_utils.ExportLib.get_best_adaptation" title="Link to this definition">#</a></dt>
<dd></dd></dl>

<dl class="py method">
<dt class="sig sig-object py" id="aidge_core.export_utils.ExportLib.get_best_match">
<span class="sig-name descname"><span class="pre">get_best_match</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">self</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">aidge_core.aidge_core.OperatorImpl</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">arg0</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><a class="reference internal" href="backend.html#aidge_core.ImplSpec" title="aidge_core.aidge_core.ImplSpec"><span class="pre">aidge_core.aidge_core.ImplSpec</span></a></span></em><span class="sig-paren">)</span> <span class="sig-return"><span class="sig-return-icon">&#x2192;</span> <span class="sig-return-typehint"><a class="reference internal" href="backend.html#aidge_core.ImplSpec" title="aidge_core.aidge_core.ImplSpec"><span class="pre">aidge_core.aidge_core.ImplSpec</span></a></span></span><a class="headerlink" href="#aidge_core.export_utils.ExportLib.get_best_match" title="Link to this definition">#</a></dt>
<dd></dd></dl>

<dl class="py method">
<dt class="sig sig-object py" id="aidge_core.export_utils.ExportLib.get_export_node">
<span class="sig-name descname"><span class="pre">get_export_node</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">spec</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><a class="reference internal" href="backend.html#aidge_core.ImplSpec" title="aidge_core.aidge_core.ImplSpec"><span class="pre">ImplSpec</span></a></span></em><span class="sig-paren">)</span> <span class="sig-return"><span class="sig-return-icon">&#x2192;</span> <span class="sig-return-typehint"><a class="reference internal" href="#aidge_core.export_utils.ExportNode" title="aidge_core.export_utils.node_export.ExportNode"><span class="pre">ExportNode</span></a></span></span><a class="headerlink" href="#aidge_core.export_utils.ExportLib.get_export_node" title="Link to this definition">#</a></dt>
<dd><p>Given an <a class="reference internal" href="backend.html#aidge_core.ImplSpec" title="aidge_core.ImplSpec"><code class="xref py py-class docutils literal notranslate"><span class="pre">aidge_core.ImplSpec</span></code></a>, return the ExportNode that is the closest match.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters<span class="colon">:</span></dt>
<dd class="field-odd"><p><strong>spec</strong> (:py:class:<a href="#id1"><span class="problematic" id="id2">`</span></a>aidge_core.ImplSpec) – Implementation specification to match</p>
</dd>
<dt class="field-even">Returns<span class="colon">:</span></dt>
<dd class="field-even"><p>The class ExportNode that is the closest match</p>
</dd>
<dt class="field-odd">Return type<span class="colon">:</span></dt>
<dd class="field-odd"><p><a class="reference internal" href="backend.html#aidge_core.ImplSpec" title="aidge_core.ImplSpec">aidge_core.ImplSpec</a></p>
</dd>
</dl>
</dd></dl>

<dl class="py method">
<dt class="sig sig-object py" id="aidge_core.export_utils.ExportLib.get_operator">
<span class="sig-name descname"><span class="pre">get_operator</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">self</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">aidge_core.aidge_core.OperatorImpl</span></span></em><span class="sig-paren">)</span> <span class="sig-return"><span class="sig-return-icon">&#x2192;</span> <span class="sig-return-typehint"><span class="pre">Aidge::Operator</span></span></span><a class="headerlink" href="#aidge_core.export_utils.ExportLib.get_operator" title="Link to this definition">#</a></dt>
<dd></dd></dl>

<dl class="py method">
<dt class="sig sig-object py" id="aidge_core.export_utils.ExportLib.get_prod_conso">
<span class="sig-name descname"><span class="pre">get_prod_conso</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">self</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">aidge_core.aidge_core.OperatorImpl</span></span></em><span class="sig-paren">)</span> <span class="sig-return"><span class="sig-return-icon">&#x2192;</span> <span class="sig-return-typehint"><span class="pre">Aidge::ProdConso</span></span></span><a class="headerlink" href="#aidge_core.export_utils.ExportLib.get_prod_conso" title="Link to this definition">#</a></dt>
<dd></dd></dl>

<dl class="py method">
<dt class="sig sig-object py" id="aidge_core.export_utils.ExportLib.get_required_spec">
<span class="sig-name descname"><span class="pre">get_required_spec</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">self</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">aidge_core.aidge_core.OperatorImpl</span></span></em><span class="sig-paren">)</span> <span class="sig-return"><span class="sig-return-icon">&#x2192;</span> <span class="sig-return-typehint"><a class="reference internal" href="backend.html#aidge_core.ImplSpec" title="aidge_core.aidge_core.ImplSpec"><span class="pre">aidge_core.aidge_core.ImplSpec</span></a></span></span><a class="headerlink" href="#aidge_core.export_utils.ExportLib.get_required_spec" title="Link to this definition">#</a></dt>
<dd></dd></dl>

<dl class="py method">
<dt class="sig sig-object py" id="aidge_core.export_utils.ExportLib.prod_conso">
<span class="sig-name descname"><span class="pre">prod_conso</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">self</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">aidge_core.aidge_core.OperatorImpl</span></span></em><span class="sig-paren">)</span> <span class="sig-return"><span class="sig-return-icon">&#x2192;</span> <span class="sig-return-typehint"><span class="pre">Aidge::ProdConso</span></span></span><a class="headerlink" href="#aidge_core.export_utils.ExportLib.prod_conso" title="Link to this definition">#</a></dt>
<dd></dd></dl>

<dl class="py method">
<dt class="sig sig-object py" id="aidge_core.export_utils.ExportLib.register">
<em class="property"><span class="pre">classmethod</span><span class="w"> </span></em><span class="sig-name descname"><span class="pre">register</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">op_type</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">spec</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#aidge_core.export_utils.ExportLib.register" title="Link to this definition">#</a></dt>
<dd><p>Decorator to register an operator implementation for a specified operator type.</p>
<p>Registers an operator under a given operator type and specification,
adding it to the export library registry. This method supports both
single operator types (str) and lists of types (List[str]).</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters<span class="colon">:</span></dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>op_type</strong> (<em>Union</em><em>[</em><em>str</em><em>, </em><em>List</em><em>[</em><em>str</em><em>]</em><em>]</em>) – The operator type(s) to register.</p></li>
<li><p><strong>spec</strong> (:py:class:<code class="docutils literal notranslate"><span class="pre">aidge_core.ImplSpec</span></code>) – Implementation specification for the operator.</p></li>
</ul>
</dd>
<dt class="field-even">Returns<span class="colon">:</span></dt>
<dd class="field-even"><p>A wrapper class that initializes the registered operator.</p>
</dd>
<dt class="field-odd">Return type<span class="colon">:</span></dt>
<dd class="field-odd"><p>Callable</p>
</dd>
</dl>
</dd></dl>

<dl class="py method">
<dt class="sig sig-object py" id="aidge_core.export_utils.ExportLib.register_generic">
<em class="property"><span class="pre">classmethod</span><span class="w"> </span></em><span class="sig-name descname"><span class="pre">register_generic</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">op_type</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">spec</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#aidge_core.export_utils.ExportLib.register_generic" title="Link to this definition">#</a></dt>
<dd><p>Decorator to register a GenericOperator with the export library.</p>
<p>Registers a GenericOperator under a given operator type and specification. This decorator
is intended for operator types that are grouped as meta operators.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters<span class="colon">:</span></dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>op_type</strong> (<em>Union</em><em>[</em><em>str</em><em>, </em><em>List</em><em>[</em><em>str</em><em>]</em><em>]</em>) – Operator type(s) to register as a <code class="docutils literal notranslate"><span class="pre">GenericOperator</span></code>.</p></li>
<li><p><strong>spec</strong> (<a class="reference internal" href="backend.html#aidge_core.ImplSpec" title="aidge_core.ImplSpec"><em>aidge_core.ImplSpec</em></a>) – Implementation specification for the GenericOperator.</p></li>
</ul>
</dd>
<dt class="field-even">Returns<span class="colon">:</span></dt>
<dd class="field-even"><p>A wrapper class that initializes the registered GenericOperator.</p>
</dd>
<dt class="field-odd">Return type<span class="colon">:</span></dt>
<dd class="field-odd"><p>Callable</p>
</dd>
</dl>
</dd></dl>

<dl class="py method">
<dt class="sig sig-object py" id="aidge_core.export_utils.ExportLib.register_metaop">
<em class="property"><span class="pre">classmethod</span><span class="w"> </span></em><span class="sig-name descname"><span class="pre">register_metaop</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">op_type</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">spec</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#aidge_core.export_utils.ExportLib.register_metaop" title="Link to this definition">#</a></dt>
<dd><p>Decorator to register a MetaOperator with the export library.</p>
<p>Registers a MetaOperator under a given operator type and specification. This decorator
is intended for operator types that are grouped as meta operators.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters<span class="colon">:</span></dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>op_type</strong> (<em>Union</em><em>[</em><em>str</em><em>, </em><em>List</em><em>[</em><em>str</em><em>]</em><em>]</em>) – Operator type(s) to register as a <code class="docutils literal notranslate"><span class="pre">MetaOperator</span></code>.</p></li>
<li><p><strong>spec</strong> (<a class="reference internal" href="backend.html#aidge_core.ImplSpec" title="aidge_core.ImplSpec"><em>aidge_core.ImplSpec</em></a>) – Implementation specification for the MetaOperator.</p></li>
</ul>
</dd>
<dt class="field-even">Returns<span class="colon">:</span></dt>
<dd class="field-even"><p>A wrapper class that initializes the registered MetaOperator.</p>
</dd>
<dt class="field-odd">Return type<span class="colon">:</span></dt>
<dd class="field-odd"><p>Callable</p>
</dd>
</dl>
</dd></dl>

</dd></dl>

</section>
<section id="export-node">
<h2>Export node<a class="headerlink" href="#export-node" title="Link to this heading">#</a></h2>
<dl class="py class">
<dt class="sig sig-object py" id="aidge_core.export_utils.ExportNode">
<em class="property"><span class="pre">class</span><span class="w"> </span></em><span class="sig-prename descclassname"><span class="pre">aidge_core.export_utils.</span></span><span class="sig-name descname"><span class="pre">ExportNode</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">aidge_node:</span> <span class="pre">~aidge_core.aidge_core.Node</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">mem_info:</span> <span class="pre">~typing.List[dict]</span> <span class="pre">|</span> <span class="pre">None</span> <span class="pre">=</span> <span class="pre">None</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">conversion_map:</span> <span class="pre">~typing.Dict[~aidge_core.aidge_core.dtype</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">str]</span> <span class="pre">=</span> <span class="pre">{&lt;dtype.float16:</span> <span class="pre">2&gt;:</span> <span class="pre">'half_float::half'</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">&lt;dtype.float32:</span> <span class="pre">1&gt;:</span> <span class="pre">'float'</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">&lt;dtype.float64:</span> <span class="pre">0&gt;:</span> <span class="pre">'double'</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">&lt;dtype.int16:</span> <span class="pre">23&gt;:</span> <span class="pre">'int16_t'</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">&lt;dtype.int32:</span> <span class="pre">24&gt;:</span> <span class="pre">'int32_t'</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">&lt;dtype.int64:</span> <span class="pre">25&gt;:</span> <span class="pre">'int64_t'</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">&lt;dtype.int8:</span> <span class="pre">22&gt;:</span> <span class="pre">'int8_t'</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">&lt;dtype.uint16:</span> <span class="pre">30&gt;:</span> <span class="pre">'uint16_t'</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">&lt;dtype.uint32:</span> <span class="pre">31&gt;:</span> <span class="pre">'uint32_t'</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">&lt;dtype.uint64:</span> <span class="pre">32&gt;:</span> <span class="pre">'uint64_t'</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">&lt;dtype.uint8:</span> <span class="pre">29&gt;:</span> <span class="pre">'uint8_t'}</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#aidge_core.export_utils.ExportNode" title="Link to this definition">#</a></dt>
<dd><p>Abstract class to interface node with export generation.</p>
<p>This class exposes a dictionary, <code class="docutils literal notranslate"><span class="pre">attributes</span></code>, which contains all the information
required to generate an export for a given node, including input/output names,
dimensions, types, and optional memory information.</p>
<ul>
<li><p>All the attributes of the Aidge Operator are automatically fetch, the key to get an attribute is the attribute name in python format, example <code class="docutils literal notranslate"><span class="pre">no_bias</span></code></p></li>
<li><p><strong>node</strong> (aidge_core.Node): The Aidge Node instance associated with this ExportNode.</p></li>
<li><p><strong>name</strong> (str): Name of the node, typically set via the Aidge node.</p></li>
<li><p><strong>nb_in</strong> (int): Number of input connections for the node.</p></li>
<li><p><strong>nb_out</strong> (int): Number of output connections for the node.</p></li>
<li><p><strong>in_name</strong> (list[str]): Unique name for each input connection.</p>
<dl class="simple">
<dt>Format:</dt><dd><ul class="simple">
<li><p>If no input node: <code class="docutils literal notranslate"><span class="pre">{node_name}_input_{in_id}</span></code></p></li>
<li><p>If there is a parent node: <code class="docutils literal notranslate"><span class="pre">{parent_name}_output_{out_id}</span></code></p></li>
</ul>
</dd>
</dl>
</li>
<li><p><strong>in_dims</strong> (list[list[int]]): Dimensions of each input.</p></li>
<li><p><strong>in_node</strong> (list[aidge_core.Node]): List of associated input nodes.</p></li>
<li><p><strong>in_size</strong> (list[int]): Size of each input.</p></li>
<li><p><strong>in_chan</strong> (list[int]): Channels in each input, based on data format.</p></li>
<li><p><strong>in_height</strong> (list[int]): Height of each input, based on data format.</p></li>
<li><p><strong>in_width</strong> (list[int]): Width of each input, based on data format.</p></li>
<li><p><strong>in_dtype</strong> (list[<code class="xref py py-class docutils literal notranslate"><span class="pre">aidge_core.dtype</span></code>]): Data type for each input (Aidge format).</p></li>
<li><p><strong>in_cdtype</strong> (list[str]): Data type for each input (C/C++ format).</p></li>
<li><p><strong>out_name</strong> (list[str]): Unique name for each output, formatted as <code class="docutils literal notranslate"><span class="pre">{name}_output_{out_id}</span></code>.</p></li>
<li><p><strong>out_node</strong> (list[list[aidge_core.Node]]): Associated output nodes for each output.</p></li>
<li><p><strong>out_dims</strong> (list[list[int]]): Dimensions of each output.</p></li>
<li><p><strong>out_size</strong> (list[int]): Size of each output.</p></li>
<li><p><strong>out_chan</strong> (list[int]): Channels in each output, based on data format.</p></li>
<li><p><strong>out_height</strong> (list[int]): Height of each output, based on data format.</p></li>
<li><p><strong>out_width</strong> (list[int]): Width of each output, based on data format.</p></li>
<li><p><strong>out_dtype</strong> (list[<code class="xref py py-class docutils literal notranslate"><span class="pre">aidge_core.dtype</span></code>]): Data type for each output (Aidge format).</p></li>
<li><p><strong>out_cdtype</strong> (list[str]): Data type for each output (C/C++ format).</p></li>
<li><p><strong>mem_info</strong> (bool): True if <cite>mem_info</cite> is available for this node.</p></li>
<li><p><strong>mem_info_size</strong> (list[int]): Memory size for each output, if applicable.</p></li>
<li><p><strong>mem_info_offset</strong> (list[int]): Offset to access each output, if applicable.</p></li>
<li><p><strong>mem_info_stride</strong> (list[int]): Stride for accessing each output.</p></li>
<li><p><strong>mem_info_length</strong> (list[int]): Length of each output.</p></li>
<li><p><strong>mem_info_cont_size</strong> (list[int]): Continuous size for each output.</p></li>
<li><p><strong>mem_info_cont_offset</strong> (list[int]): Continuous offset for each output.</p></li>
<li><p><strong>mem_info_wrap_offset</strong> (list[int]): Wrap offset for each output.</p></li>
<li><p><strong>mem_info_wrap_size</strong> (list[int]): Wrap size for each output.</p></li>
</ul>
<dl class="py method">
<dt class="sig sig-object py" id="aidge_core.export_utils.ExportNode.__init__">
<em class="property"><span class="pre">abstract</span><span class="w"> </span></em><span class="sig-name descname"><span class="pre">__init__</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">aidge_node:</span> <span class="pre">~aidge_core.aidge_core.Node</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">mem_info:</span> <span class="pre">~typing.List[dict]</span> <span class="pre">|</span> <span class="pre">None</span> <span class="pre">=</span> <span class="pre">None</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">conversion_map:</span> <span class="pre">~typing.Dict[~aidge_core.aidge_core.dtype</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">str]</span> <span class="pre">=</span> <span class="pre">{&lt;dtype.float16:</span> <span class="pre">2&gt;:</span> <span class="pre">'half_float::half'</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">&lt;dtype.float32:</span> <span class="pre">1&gt;:</span> <span class="pre">'float'</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">&lt;dtype.float64:</span> <span class="pre">0&gt;:</span> <span class="pre">'double'</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">&lt;dtype.int16:</span> <span class="pre">23&gt;:</span> <span class="pre">'int16_t'</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">&lt;dtype.int32:</span> <span class="pre">24&gt;:</span> <span class="pre">'int32_t'</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">&lt;dtype.int64:</span> <span class="pre">25&gt;:</span> <span class="pre">'int64_t'</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">&lt;dtype.int8:</span> <span class="pre">22&gt;:</span> <span class="pre">'int8_t'</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">&lt;dtype.uint16:</span> <span class="pre">30&gt;:</span> <span class="pre">'uint16_t'</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">&lt;dtype.uint32:</span> <span class="pre">31&gt;:</span> <span class="pre">'uint32_t'</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">&lt;dtype.uint64:</span> <span class="pre">32&gt;:</span> <span class="pre">'uint64_t'</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">&lt;dtype.uint8:</span> <span class="pre">29&gt;:</span> <span class="pre">'uint8_t'}</span></span></em><span class="sig-paren">)</span> <span class="sig-return"><span class="sig-return-icon">&#x2192;</span> <span class="sig-return-typehint"><span class="pre">None</span></span></span><a class="headerlink" href="#aidge_core.export_utils.ExportNode.__init__" title="Link to this definition">#</a></dt>
<dd><p>Create ExportNode and retrieve attributes from <code class="docutils literal notranslate"><span class="pre">aidge_node</span></code>:</p>
</dd></dl>

</dd></dl>

<dl class="py class">
<dt class="sig sig-object py" id="aidge_core.export_utils.ExportNodeCpp">
<em class="property"><span class="pre">class</span><span class="w"> </span></em><span class="sig-prename descclassname"><span class="pre">aidge_core.export_utils.</span></span><span class="sig-name descname"><span class="pre">ExportNodeCpp</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">aidge_node:</span> <span class="pre">~aidge_core.aidge_core.Node</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">mem_info:</span> <span class="pre">~typing.List[dict]</span> <span class="pre">|</span> <span class="pre">None</span> <span class="pre">=</span> <span class="pre">None</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">conversion_map:</span> <span class="pre">~typing.Dict[~aidge_core.aidge_core.dtype</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">str]</span> <span class="pre">=</span> <span class="pre">{&lt;dtype.float16:</span> <span class="pre">2&gt;:</span> <span class="pre">'half_float::half'</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">&lt;dtype.float32:</span> <span class="pre">1&gt;:</span> <span class="pre">'float'</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">&lt;dtype.float64:</span> <span class="pre">0&gt;:</span> <span class="pre">'double'</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">&lt;dtype.int16:</span> <span class="pre">23&gt;:</span> <span class="pre">'int16_t'</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">&lt;dtype.int32:</span> <span class="pre">24&gt;:</span> <span class="pre">'int32_t'</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">&lt;dtype.int64:</span> <span class="pre">25&gt;:</span> <span class="pre">'int64_t'</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">&lt;dtype.int8:</span> <span class="pre">22&gt;:</span> <span class="pre">'int8_t'</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">&lt;dtype.uint16:</span> <span class="pre">30&gt;:</span> <span class="pre">'uint16_t'</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">&lt;dtype.uint32:</span> <span class="pre">31&gt;:</span> <span class="pre">'uint32_t'</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">&lt;dtype.uint64:</span> <span class="pre">32&gt;:</span> <span class="pre">'uint64_t'</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">&lt;dtype.uint8:</span> <span class="pre">29&gt;:</span> <span class="pre">'uint8_t'}</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#aidge_core.export_utils.ExportNodeCpp" title="Link to this definition">#</a></dt>
<dd><p>Class for exporting Aidge nodes with C++ code generation.</p>
<p>This subclass of <a class="reference internal" href="#aidge_core.export_utils.ExportNode" title="aidge_core.export_utils.ExportNode"><code class="xref py py-class docutils literal notranslate"><span class="pre">ExportNode</span></code></a> defines specific templates,
configuration paths, and other attributes required to generate
C++ code for Aidge nodes, including header and source files
for node definitions and forward passes.</p>
<dl class="field-list simple">
<dt class="field-odd">Variables<span class="colon">:</span></dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>config_template</strong> (<em>str</em>) – Path to the template defining how to export the node definition.
This template is required for exporting; if undefined, raises an error, if no config
template is required set this to an empty string.</p></li>
<li><p><strong>forward_template</strong> (<em>str</em>) – Path to the template for generating code to perform a forward pass
of the node. Required for exporting the forward pass; raises an error if undefined.</p></li>
<li><p><strong>include_list</strong> (<em>list</em><em>[</em><em>str</em><em>]</em>) – List of include paths (e.g., “include/toto.hpp”) to be added to
the generated export files. Must be defined before export; raises an error if undefined.</p></li>
<li><p><strong>kernels_to_copy</strong> (<em>list</em><em>[</em><em>str</em><em>]</em>) – List of paths to kernel files that should be copied during
export. The kernels are copied to <code class="docutils literal notranslate"><span class="pre">kernels_path</span></code>, and are automatically
added to the include list.</p></li>
<li><p><strong>kernels_path</strong> (<em>str</em>) – Path where all kernels are stored in the export, prefixed by the
<cite>export_root</cite>. Defaults to “include/kernels”.</p></li>
<li><p><strong>config_path</strong> (<em>str</em>) – Path of the configuration folder where node definitions are exported.
Defaults to “include/layers”.</p></li>
<li><p><strong>config_extension</strong> (<em>str</em>) – File extension for the configuration files, typically for header
files. Defaults to “h”.</p></li>
</ul>
</dd>
</dl>
<dl class="py method">
<dt class="sig sig-object py" id="aidge_core.export_utils.ExportNodeCpp.__init__">
<em class="property"><span class="pre">abstract</span><span class="w"> </span></em><span class="sig-name descname"><span class="pre">__init__</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">aidge_node:</span> <span class="pre">~aidge_core.aidge_core.Node</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">mem_info:</span> <span class="pre">~typing.List[dict]</span> <span class="pre">|</span> <span class="pre">None</span> <span class="pre">=</span> <span class="pre">None</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">conversion_map:</span> <span class="pre">~typing.Dict[~aidge_core.aidge_core.dtype</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">str]</span> <span class="pre">=</span> <span class="pre">{&lt;dtype.float16:</span> <span class="pre">2&gt;:</span> <span class="pre">'half_float::half'</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">&lt;dtype.float32:</span> <span class="pre">1&gt;:</span> <span class="pre">'float'</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">&lt;dtype.float64:</span> <span class="pre">0&gt;:</span> <span class="pre">'double'</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">&lt;dtype.int16:</span> <span class="pre">23&gt;:</span> <span class="pre">'int16_t'</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">&lt;dtype.int32:</span> <span class="pre">24&gt;:</span> <span class="pre">'int32_t'</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">&lt;dtype.int64:</span> <span class="pre">25&gt;:</span> <span class="pre">'int64_t'</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">&lt;dtype.int8:</span> <span class="pre">22&gt;:</span> <span class="pre">'int8_t'</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">&lt;dtype.uint16:</span> <span class="pre">30&gt;:</span> <span class="pre">'uint16_t'</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">&lt;dtype.uint32:</span> <span class="pre">31&gt;:</span> <span class="pre">'uint32_t'</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">&lt;dtype.uint64:</span> <span class="pre">32&gt;:</span> <span class="pre">'uint64_t'</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">&lt;dtype.uint8:</span> <span class="pre">29&gt;:</span> <span class="pre">'uint8_t'}</span></span></em><span class="sig-paren">)</span> <span class="sig-return"><span class="sig-return-icon">&#x2192;</span> <span class="sig-return-typehint"><span class="pre">None</span></span></span><a class="headerlink" href="#aidge_core.export_utils.ExportNodeCpp.__init__" title="Link to this definition">#</a></dt>
<dd><p>Create ExportNode and retrieve attributes from <code class="docutils literal notranslate"><span class="pre">aidge_node</span></code>:</p>
</dd></dl>

<dl class="py method">
<dt class="sig sig-object py" id="aidge_core.export_utils.ExportNodeCpp.export">
<span class="sig-name descname"><span class="pre">export</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">export_folder</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">str</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#aidge_core.export_utils.ExportNodeCpp.export" title="Link to this definition">#</a></dt>
<dd><p>Defines how to export the node definition.</p>
<p>This method checks that <cite>config_template</cite>, <cite>include_list</cite>, and
<cite>kernels_to_copy</cite> are defined, then copies each kernel to the export folder,
appends their paths to the include list, and generates the configuration file
based on the <cite>config_template</cite>.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters<span class="colon">:</span></dt>
<dd class="field-odd"><p><strong>export_folder</strong> (<em>str</em>) – Folder path where the files are exported.</p>
</dd>
<dt class="field-even">Returns<span class="colon">:</span></dt>
<dd class="field-even"><p>List of include paths with the paths for kernels and configuration files.</p>
</dd>
<dt class="field-odd">Return type<span class="colon">:</span></dt>
<dd class="field-odd"><p>list[str]</p>
</dd>
</dl>
</dd></dl>

<dl class="py method">
<dt class="sig sig-object py" id="aidge_core.export_utils.ExportNodeCpp.forward">
<span class="sig-name descname"><span class="pre">forward</span></span><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="headerlink" href="#aidge_core.export_utils.ExportNodeCpp.forward" title="Link to this definition">#</a></dt>
<dd><p>Generates code for a forward pass using the <cite>forward_template</cite>.</p>
</dd></dl>

</dd></dl>

</section>
<section id="export-scheduler">
<h2>Export scheduler<a class="headerlink" href="#export-scheduler" title="Link to this heading">#</a></h2>
<dl class="py function">
<dt class="sig sig-object py" id="aidge_core.export_utils.scheduler_export">
<span class="sig-prename descclassname"><span class="pre">aidge_core.export_utils.</span></span><span class="sig-name descname"><span class="pre">scheduler_export</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">scheduler</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">export_folder_path</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">str</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">export_lib</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><a class="reference internal" href="#aidge_core.export_utils.ExportLib" title="aidge_core.export_utils.export_registry.ExportLib"><span class="pre">ExportLib</span></a><span class="w"> </span><span class="p"><span class="pre">|</span></span><span class="w"> </span><span class="pre">None</span></span><span class="w"> </span><span class="o"><span class="pre">=</span></span><span class="w"> </span><span class="default_value"><span class="pre">None</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">memory_manager</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">None</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">memory_manager_args</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">None</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">test_mode</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">False</span></span></em><span class="sig-paren">)</span> <span class="sig-return"><span class="sig-return-icon">&#x2192;</span> <span class="sig-return-typehint"><span class="pre">None</span></span></span><a class="headerlink" href="#aidge_core.export_utils.scheduler_export" title="Link to this definition">#</a></dt>
<dd><p>Exports an aidge_core.Scheduler to C++ code.</p>
<p>This function generates files for a given computation graph, including forward-pass functions,
configuration headers, and the main API entry point for the exported model. It requires a
memory manager to allocate resources, and optionally an <cite>ExportLib</cite> instance to handle backend
configurations for node operators.</p>
<ol class="arabic">
<li><dl class="simple">
<dt><strong>Export Preparation</strong>:</dt><dd><ul class="simple">
<li><p>Initializes export and DNN folders, checking that required memory management functions are defined.</p></li>
<li><p>Retrieves peak memory usage and memory details for each node using the <cite>memory_manager</cite>.</p></li>
</ul>
</dd>
</dl>
</li>
<li><dl class="simple">
<dt><strong>Configuration Generation</strong>:</dt><dd><ul class="simple">
<li><p>Iterates over nodes scheduled by <cite>scheduler</cite>, configuring backends if <cite>export_lib</cite> is specified.</p></li>
<li><dl class="simple">
<dt>Exports configuration headers and forward-pass actions for each node by invoking <cite>op.export()</cite></dt><dd><p>and <cite>op.forward()</cite>, appending these to <cite>list_configs</cite> and <cite>list_actions</cite>, respectively.</p>
</dd>
</dl>
</li>
<li><p>Collects information on input and output nodes, including their names, data types, and sizes.</p></li>
</ul>
</dd>
</dl>
</li>
<li><dl>
<dt><strong>Code Generation</strong>:</dt><dd><ul>
<li><p>Defines the forward-pass function, <cite>model_forward</cite>, with inputs and outputs based on node attributes.</p></li>
<li><p>Generates the following files:</p>
<blockquote>
<div><ul class="simple">
<li><p><strong>forward.cpp</strong>: Implements the model forward pass using templates, applying configurations</p></li>
</ul>
<p>and actions for each node.</p>
<ul class="simple">
<li><p><strong>forward.hpp</strong>: Exports the forward API, defining inputs and outputs.</p></li>
<li><p><strong>main.cpp</strong>: Main entry file, serving as the model’s forward-pass interface.</p></li>
</ul>
</div></blockquote>
</li>
</ul>
</dd>
</dl>
</li>
<li><dl>
<dt><strong>Static File Export (Optional)</strong>:</dt><dd><ul class="simple">
<li><p>If <cite>export_lib</cite> is specified, static files are copied to the export folder based on <cite>export_lib</cite></p></li>
</ul>
<p>specifications.</p>
</dd>
</dl>
</li>
</ol>
<dl class="field-list simple">
<dt class="field-odd">Parameters<span class="colon">:</span></dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>scheduler</strong> (<a class="reference internal" href="scheduler.html#aidge_core.Scheduler" title="aidge_core.Scheduler"><em>aidge_core.Scheduler</em></a>) – Scheduler instance managing the computation graph.
Uses <cite>graph_view</cite> and <cite>get_static_scheduling</cite> methods
to retrieve the computation graph layout and ordered nodes.</p></li>
<li><p><strong>export_folder_path</strong> (<em>str</em>) – Path to the folder where the generated export files will be saved.
Creates this folder, along with subdirectories for model and source files.</p></li>
<li><p><strong>export_lib</strong> (<a class="reference internal" href="#aidge_core.export_utils.ExportLib" title="aidge_core.export_utils.ExportLib"><em>ExportLib</em></a><em>, </em><em>optional</em>) – Library providing the backend implementation for node operators.
Defaults to None. If provided, each node’s backend is set to the library’s name.</p></li>
<li><p><strong>memory_manager</strong> (<em>callable</em>) – Required function for managing memory allocation. It should take
<cite>scheduler</cite> and optional <cite>memory_manager_args</cite> as parameters, returning
<cite>peak_mem</cite> (peak memory usage) and <cite>mem_info</cite> (memory details for each node).</p></li>
<li><p><strong>memory_manager_args</strong> (<em>dict</em><em>, </em><em>optional</em>) – Additional arguments passed to <cite>memory_manager</cite>. Defaults to an empty dictionary.</p></li>
<li><p><strong>test_mode</strong> (<em>bool</em><em>, </em><em>optional</em>) – Additional argument which may be used during forward generation.</p></li>
</ul>
</dd>
</dl>
</dd></dl>

</section>
</section>


                </article>
              
              
              
              
              
                <footer class="prev-next-footer d-print-none">
                  
<div class="prev-next-area">
    <a class="left-prev"
       href="recipes.html"
       title="previous page">
      <i class="fa-solid fa-angle-left"></i>
      <div class="prev-next-info">
        <p class="prev-next-subtitle">previous</p>
        <p class="prev-next-title">Recipes</p>
      </div>
    </a>
    <a class="right-next"
       href="../BackendCPU/index.html"
       title="next page">
      <div class="prev-next-info">
        <p class="prev-next-subtitle">next</p>
        <p class="prev-next-title">Aidge backend CPU</p>
      </div>
      <i class="fa-solid fa-angle-right"></i>
    </a>
</div>
                </footer>
              
            </div>
            
            
              
                <dialog id="pst-secondary-sidebar-modal"></dialog>
                <div id="pst-secondary-sidebar" class="bd-sidebar-secondary bd-toc"><div class="sidebar-secondary-items sidebar-secondary__inner">


  <div class="sidebar-secondary-item">
<div
    id="pst-page-navigation-heading-2"
    class="page-toc tocsection onthispage">
    <i class="fa-solid fa-list"></i> On this page
  </div>
  <nav class="bd-toc-nav page-toc" aria-labelledby="pst-page-navigation-heading-2">
    <ul class="visible nav section-nav flex-column">
<li class="toc-h2 nav-item toc-entry"><a class="reference internal nav-link" href="#export-lib">Export lib</a><ul class="visible nav section-nav flex-column">
<li class="toc-h3 nav-item toc-entry"><a class="reference internal nav-link" href="#aidge_core.export_utils.ExportLib"><code class="docutils literal notranslate"><span class="pre">ExportLib</span></code></a><ul class="visible nav section-nav flex-column">
<li class="toc-h4 nav-item toc-entry"><a class="reference internal nav-link" href="#aidge_core.export_utils.ExportLib.__init__"><code class="docutils literal notranslate"><span class="pre">ExportLib.__init__()</span></code></a></li>
<li class="toc-h4 nav-item toc-entry"><a class="reference internal nav-link" href="#aidge_core.export_utils.ExportLib.backend"><code class="docutils literal notranslate"><span class="pre">ExportLib.backend()</span></code></a></li>
<li class="toc-h4 nav-item toc-entry"><a class="reference internal nav-link" href="#aidge_core.export_utils.ExportLib.backward"><code class="docutils literal notranslate"><span class="pre">ExportLib.backward()</span></code></a></li>
<li class="toc-h4 nav-item toc-entry"><a class="reference internal nav-link" href="#aidge_core.export_utils.ExportLib.forward"><code class="docutils literal notranslate"><span class="pre">ExportLib.forward()</span></code></a></li>
<li class="toc-h4 nav-item toc-entry"><a class="reference internal nav-link" href="#aidge_core.export_utils.ExportLib.get_adaptation"><code class="docutils literal notranslate"><span class="pre">ExportLib.get_adaptation()</span></code></a></li>
<li class="toc-h4 nav-item toc-entry"><a class="reference internal nav-link" href="#aidge_core.export_utils.ExportLib.get_available_impl_specs"><code class="docutils literal notranslate"><span class="pre">ExportLib.get_available_impl_specs()</span></code></a></li>
<li class="toc-h4 nav-item toc-entry"><a class="reference internal nav-link" href="#aidge_core.export_utils.ExportLib.get_best_adaptation"><code class="docutils literal notranslate"><span class="pre">ExportLib.get_best_adaptation()</span></code></a></li>
<li class="toc-h4 nav-item toc-entry"><a class="reference internal nav-link" href="#aidge_core.export_utils.ExportLib.get_best_match"><code class="docutils literal notranslate"><span class="pre">ExportLib.get_best_match()</span></code></a></li>
<li class="toc-h4 nav-item toc-entry"><a class="reference internal nav-link" href="#aidge_core.export_utils.ExportLib.get_export_node"><code class="docutils literal notranslate"><span class="pre">ExportLib.get_export_node()</span></code></a></li>
<li class="toc-h4 nav-item toc-entry"><a class="reference internal nav-link" href="#aidge_core.export_utils.ExportLib.get_operator"><code class="docutils literal notranslate"><span class="pre">ExportLib.get_operator()</span></code></a></li>
<li class="toc-h4 nav-item toc-entry"><a class="reference internal nav-link" href="#aidge_core.export_utils.ExportLib.get_prod_conso"><code class="docutils literal notranslate"><span class="pre">ExportLib.get_prod_conso()</span></code></a></li>
<li class="toc-h4 nav-item toc-entry"><a class="reference internal nav-link" href="#aidge_core.export_utils.ExportLib.get_required_spec"><code class="docutils literal notranslate"><span class="pre">ExportLib.get_required_spec()</span></code></a></li>
<li class="toc-h4 nav-item toc-entry"><a class="reference internal nav-link" href="#aidge_core.export_utils.ExportLib.prod_conso"><code class="docutils literal notranslate"><span class="pre">ExportLib.prod_conso()</span></code></a></li>
<li class="toc-h4 nav-item toc-entry"><a class="reference internal nav-link" href="#aidge_core.export_utils.ExportLib.register"><code class="docutils literal notranslate"><span class="pre">ExportLib.register()</span></code></a></li>
<li class="toc-h4 nav-item toc-entry"><a class="reference internal nav-link" href="#aidge_core.export_utils.ExportLib.register_generic"><code class="docutils literal notranslate"><span class="pre">ExportLib.register_generic()</span></code></a></li>
<li class="toc-h4 nav-item toc-entry"><a class="reference internal nav-link" href="#aidge_core.export_utils.ExportLib.register_metaop"><code class="docutils literal notranslate"><span class="pre">ExportLib.register_metaop()</span></code></a></li>
</ul>
</li>
</ul>
</li>
<li class="toc-h2 nav-item toc-entry"><a class="reference internal nav-link" href="#export-node">Export node</a><ul class="visible nav section-nav flex-column">
<li class="toc-h3 nav-item toc-entry"><a class="reference internal nav-link" href="#aidge_core.export_utils.ExportNode"><code class="docutils literal notranslate"><span class="pre">ExportNode</span></code></a><ul class="visible nav section-nav flex-column">
<li class="toc-h4 nav-item toc-entry"><a class="reference internal nav-link" href="#aidge_core.export_utils.ExportNode.__init__"><code class="docutils literal notranslate"><span class="pre">ExportNode.__init__()</span></code></a></li>
</ul>
</li>
<li class="toc-h3 nav-item toc-entry"><a class="reference internal nav-link" href="#aidge_core.export_utils.ExportNodeCpp"><code class="docutils literal notranslate"><span class="pre">ExportNodeCpp</span></code></a><ul class="visible nav section-nav flex-column">
<li class="toc-h4 nav-item toc-entry"><a class="reference internal nav-link" href="#aidge_core.export_utils.ExportNodeCpp.__init__"><code class="docutils literal notranslate"><span class="pre">ExportNodeCpp.__init__()</span></code></a></li>
<li class="toc-h4 nav-item toc-entry"><a class="reference internal nav-link" href="#aidge_core.export_utils.ExportNodeCpp.export"><code class="docutils literal notranslate"><span class="pre">ExportNodeCpp.export()</span></code></a></li>
<li class="toc-h4 nav-item toc-entry"><a class="reference internal nav-link" href="#aidge_core.export_utils.ExportNodeCpp.forward"><code class="docutils literal notranslate"><span class="pre">ExportNodeCpp.forward()</span></code></a></li>
</ul>
</li>
</ul>
</li>
<li class="toc-h2 nav-item toc-entry"><a class="reference internal nav-link" href="#export-scheduler">Export scheduler</a><ul class="visible nav section-nav flex-column">
<li class="toc-h3 nav-item toc-entry"><a class="reference internal nav-link" href="#aidge_core.export_utils.scheduler_export"><code class="docutils literal notranslate"><span class="pre">scheduler_export()</span></code></a></li>
</ul>
</li>
</ul>
  </nav></div>

  <div class="sidebar-secondary-item">

  
  <div class="tocsection editthispage">
    <a href="https://gitlab.eclipse.org/eclipse/aidge/aidge/-/edit/master/docs/source/API/Core/export.rst">
      <i class="fa-solid fa-pencil"></i>
      
      
        
          Edit on GitLab
        
      
    </a>
  </div>
</div>

  <div class="sidebar-secondary-item">
  <div role="note" aria-label="source link">
    <h3>This Page</h3>
    <ul class="this-page-menu">
      <li><a href="../../../_sources/source/API/Core/export.rst.txt"
            rel="nofollow">Show Source</a></li>
    </ul>
   </div></div>

</div></div>
              
            
          </div>
          <footer class="bd-footer-content">
            
          </footer>
        
      </main>
    </div>
  </div>
  
  <!-- Scripts loaded after <body> so the DOM is not blocked -->
  <script defer src="../../../_static/scripts/bootstrap.js?digest=8878045cc6db502f8baf"></script>
<script defer src="../../../_static/scripts/pydata-sphinx-theme.js?digest=8878045cc6db502f8baf"></script>

  <footer class="bd-footer">
<div class="bd-footer__inner bd-page-width">
  
    <div class="footer-items__start">
      
        <div class="footer-item">

  <p class="copyright">
    
      © Copyright 2023, CEA LIST.
      <br/>
    
  </p>
</div>
      
        <div class="footer-item">

  <p class="sphinx-version">
    Created using <a href="https://www.sphinx-doc.org/">Sphinx</a> 8.1.3.
    <br/>
  </p>
</div>
      
    </div>
  
  
  
    <div class="footer-items__end">
      
        <div class="footer-item">
<p class="theme-version">
  <!-- # L10n: Setting the PST URL as an argument as this does not need to be localized -->
  Built with the <a href="https://pydata-sphinx-theme.readthedocs.io/en/stable/index.html">PyData Sphinx Theme</a> 0.16.1.
</p></div>
      
    </div>
  
</div>

  </footer>
  </body>
</html>